## ros-crystal-behaviortree-cpp 2.4.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12) # version on Ubuntu Trusty
project(behaviortree_cpp)

if(NOT CMAKE_VERSION VERSION_LESS 3.1)
    set(CMAKE_CXX_STANDARD 11)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
endif()

set(CMAKE_POSITION_INDEPENDENT_CODE ON)


set(CMAKE_CONFIG_PATH ${CMAKE_MODULE_PATH}  "${CMAKE_CURRENT_LIST_DIR}/cmake")
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CONFIG_PATH}")

option(BUILD_EXAMPLES   "Build tutorials and examples" ON)
option(BUILD_UNIT_TESTS "Build the unit tests" ON)

#############################################################
# Find packages
find_package(Threads REQUIRED)
find_package(ZMQ)

list(APPEND BEHAVIOR_TREE_EXTERNAL_LIBRARIES ${CMAKE_THREAD_LIBS_INIT} ${CMAKE_DL_LIBS})

if( ZMQ_FOUND )
    message(STATUS "ZeroMQ found.")
    add_definitions( -DZMQ_FOUND )
    list(APPEND BT_SOURCE src/loggers/bt_zmq_publisher.cpp)
    list(APPEND BEHAVIOR_TREE_EXTERNAL_LIBRARIES zmq)
else()
    message(WARNING "ZeroMQ NOT found. Skipping the build of [PublisherZMQ] and [bt_recorder].")
endif()

set(BEHAVIOR_TREE_LIBRARY ${PROJECT_NAME})

# Update the policy setting to avoid an error when loading the ament_cmake package
# at the current cmake version level
if(POLICY CMP0057)
   cmake_policy(SET CMP0057 NEW)
endif()

find_package(ament_cmake QUIET)

if ( ament_cmake_FOUND )
  # Not adding -DUSING_ROS since xml_parsing.cpp hasn't been ported to ROS2

  message(STATUS "------------------------------------------")
  message(STATUS "BehaviourTree is being built using AMENT.")
  message(STATUS "------------------------------------------")

  set(BUILD_TOOL_INCLUDE_DIRS ${ament_INCLUDE_DIRS})

elseif( CATKIN_DEVEL_PREFIX OR CATKIN_BUILD_BINARY_PACKAGE)

  set(catkin_FOUND 1)
  add_definitions( -DUSING_ROS )
  find_package(catkin REQUIRED COMPONENTS roslib)
  find_package(GTest)

  message(STATUS "------------------------------------------")
  message(STATUS "BehaviourTree is being built using CATKIN.")
  message(STATUS "------------------------------------------")

  catkin_package(
    INCLUDE_DIRS include # do not include "3rdparty" here
    LIBRARIES ${BEHAVIOR_TREE_LIBRARY}
    CATKIN_DEPENDS roslib
    )

  list(APPEND BEHAVIOR_TREE_EXTERNAL_LIBRARIES ${catkin_LIBRARIES})
  set(BUILD_TOOL_INCLUDE_DIRS ${catkin_INCLUDE_DIRS})

else()
    find_package(GTest)

    if(NOT GTEST_FOUND)
      message(WARNING " GTest not found!")
    endif(NOT GTEST_FOUND)

    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

endif()

#############################################################
# LIBRARY

list(APPEND BT_SOURCE
    src/action_node.cpp
    src/basic_types.cpp
    src/decorator_node.cpp
    src/condition_node.cpp
    src/control_node.cpp
    src/exceptions.cpp
    src/leaf_node.cpp
    src/tick_engine.cpp
    src/tree_node.cpp
    src/bt_factory.cpp
    src/behavior_tree.cpp
    src/xml_parsing.cpp
    src/shared_library.cpp
    src/shared_library_UNIX.cpp

    src/decorators/inverter_node.cpp
    src/decorators/repeat_node.cpp
    src/decorators/retry_node.cpp
    src/decorators/timeout_node.cpp
    src/decorators/subtree_node.cpp

    src/controls/parallel_node.cpp
    src/controls/sequence_node.cpp
    src/controls/sequence_star_node.cpp
    src/controls/fallback_node.cpp
    src/controls/fallback_star_node.cpp

    src/loggers/bt_cout_logger.cpp
    src/loggers/bt_file_logger.cpp
    src/loggers/bt_minitrace_logger.cpp

    3rdparty/tinyXML2/tinyxml2.cpp
    3rdparty/minitrace/minitrace.cpp
    )



add_library(${BEHAVIOR_TREE_LIBRARY} SHARED ${BT_SOURCE} )
target_link_libraries(${BEHAVIOR_TREE_LIBRARY} PUBLIC
    ${BEHAVIOR_TREE_EXTERNAL_LIBRARIES})

target_include_directories(${BEHAVIOR_TREE_LIBRARY} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/3rdparty>
    $<INSTALL_INTERFACE:3rdparty>
    ${BUILD_TOOL_INCLUDE_DIRS})

if(MSVC)
  target_compile_options(${BEHAVIOR_TREE_LIBRARY} PRIVATE /W4 /WX)
else()
  target_compile_options(${BEHAVIOR_TREE_LIBRARY} PRIVATE -Wall -Wextra -Werror=return-type)
endif()

######################################################
# EXPORTS

set(PROJECT_NAMESPACE BehaviorTree)
set(PROJECT_CONFIG ${PROJECT_NAMESPACE}Config)
export(TARGETS ${PROJECT_NAME}
       NAMESPACE ${PROJECT_NAMESPACE}::
       FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_CONFIG}.cmake")

######################################################
# TESTS

set(BT_TESTS
  gtest/src/action_test_node.cpp
  gtest/src/condition_test_node.cpp
  gtest/gtest_tree.cpp
  gtest/gtest_sequence.cpp
  gtest/gtest_parallel.cpp
  gtest/gtest_fallback.cpp
  gtest/gtest_factory.cpp
  gtest/gtest_decorator.cpp
)

if(ament_cmake_FOUND AND BUILD_TESTING)

    find_package(ament_cmake_gtest REQUIRED)

    ament_add_gtest_executable(${BEHAVIOR_TREE_LIBRARY}_test ${BT_TESTS})
    target_link_libraries(${BEHAVIOR_TREE_LIBRARY}_test ${BEHAVIOR_TREE_LIBRARY}
                                                        crossdoor_nodes
                                                        ${ament_LIBRARIES})
    target_include_directories(${BEHAVIOR_TREE_LIBRARY}_test PRIVATE gtest/include)
    include_directories($<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/3rdparty>)

elseif(catkin_FOUND AND CATKIN_ENABLE_TESTING)

    catkin_add_gtest(${BEHAVIOR_TREE_LIBRARY}_test ${BT_TESTS})
    target_link_libraries(${BEHAVIOR_TREE_LIBRARY}_test ${BEHAVIOR_TREE_LIBRARY}
                                                        crossdoor_nodes
                                                        ${catkin_LIBRARIES})
    target_include_directories(${BEHAVIOR_TREE_LIBRARY}_test PRIVATE gtest/include)

elseif(GTEST_FOUND AND BUILD_UNIT_TESTS)

    enable_testing()

    add_executable(${BEHAVIOR_TREE_LIBRARY}_test ${BT_TESTS})
    target_link_libraries(${PROJECT_NAME}_test ${BEHAVIOR_TREE_LIBRARY}
                                                crossdoor_nodes
                                                ${GTEST_LIBRARIES}
                                                ${GTEST_MAIN_LIBRARIES})
    target_include_directories(${BEHAVIOR_TREE_LIBRARY}_test PRIVATE gtest/include ${GTEST_INCLUDE_DIRS})

    add_test(BehaviorTreeCoreTest ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${BEHAVIOR_TREE_LIBRARY}_test)
endif()

######################################################
# INSTALL
if(ament_cmake_FOUND)
    set( BEHAVIOR_TREE_LIB_DESTINATION   lib )
    set( BEHAVIOR_TREE_INC_DESTINATION   include )
    set( BEHAVIOR_TREE_BIN_DESTINATION   bin )

    ament_export_include_directories(include)
    ament_export_libraries(${BEHAVIOR_TREE_LIBRARY})
    ament_package()
elseif(catkin_FOUND)
    set( BEHAVIOR_TREE_LIB_DESTINATION   ${CATKIN_PACKAGE_LIB_DESTINATION} )
    set( BEHAVIOR_TREE_INC_DESTINATION   ${CATKIN_PACKAGE_INCLUDE_DESTINATION} )
    set( BEHAVIOR_TREE_BIN_DESTINATION   ${CATKIN_PACKAGE_BIN_DESTINATION} )
else()
    set( BEHAVIOR_TREE_LIB_DESTINATION   lib )
    set( BEHAVIOR_TREE_INC_DESTINATION   include )
    set( BEHAVIOR_TREE_BIN_DESTINATION   bin )
endif()

message(STATUS "BEHAVIOR_TREE_LIB_DESTINATION: ${BEHAVIOR_TREE_LIB_DESTINATION}")
message(STATUS "BEHAVIOR_TREE_INC_DESTINATION: ${BEHAVIOR_TREE_INC_DESTINATION}")
message(STATUS "BEHAVIOR_TREE_BIN_DESTINATION: ${BEHAVIOR_TREE_BIN_DESTINATION}")

INSTALL(TARGETS ${BEHAVIOR_TREE_LIBRARY}
    EXPORT ${PROJECT_CONFIG}
    ARCHIVE DESTINATION ${BEHAVIOR_TREE_LIB_DESTINATION}
    LIBRARY DESTINATION ${BEHAVIOR_TREE_LIB_DESTINATION}
    )

INSTALL( DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/
    DESTINATION ${BEHAVIOR_TREE_INC_DESTINATION}
    FILES_MATCHING PATTERN "*.h*")

install(EXPORT ${PROJECT_CONFIG}
    DESTINATION "${BEHAVIOR_TREE_LIB_DESTINATION}/${PROJECT_NAMESPACE}/cmake"
    NAMESPACE ${PROJECT_NAMESPACE}::)

######################################################
# EXAMPLES and TOOLS

if( BUILD_EXAMPLES )
    add_subdirectory(tools)
    add_subdirectory(sample_nodes)
    add_subdirectory(examples)
endif()

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)


# This tutorial demonstrates how to compile statically a tree (no factory)
add_executable(t01_programmatic_tree         t01_programmatic_tree.cpp )
target_link_libraries(t01_programmatic_tree  dummy_nodes ${BEHAVIOR_TREE_LIBRARY}  )

# The plugin libdummy_nodes.so can be linked statically or
# loaded dynamically at run-time.
add_executable(t02_factory_static  t02_factory_tree.cpp )
target_compile_definitions(t02_factory_static PRIVATE "MANUAL_STATIC_LINKING")
target_link_libraries(t02_factory_static ${BEHAVIOR_TREE_LIBRARY}   dummy_nodes )

add_executable(t02_factory_dynamic  t02_factory_tree.cpp )
target_link_libraries(t02_factory_dynamic ${BEHAVIOR_TREE_LIBRARY}  )


# This tutorial shows how the difference between Sequence and SequenceStar
add_executable(t03_sequence_star        t03_sequence_star.cpp )
target_link_libraries(t03_sequence_star movebase_node dummy_nodes ${BEHAVIOR_TREE_LIBRARY}  )

# This tutorial demonstrates how to use blackboards and NodeParameters
add_executable(t04_blackboard         t04_blackboard.cpp )
target_link_libraries(t04_blackboard  movebase_node ${BEHAVIOR_TREE_LIBRARY}  )

add_executable(t05_crossdoor         t05_crossdoor.cpp )
target_link_libraries(t05_crossdoor  crossdoor_nodes ${BEHAVIOR_TREE_LIBRARY}  )

add_executable(t06_wrap_legacy         t06_wrap_legacy.cpp )
target_link_libraries(t06_wrap_legacy  crossdoor_nodes ${BEHAVIOR_TREE_LIBRARY}  )

add_executable(t07_include_trees  t07_include_trees.cpp )
target_link_libraries(t07_include_trees ${BEHAVIOR_TREE_LIBRARY}   dummy_nodes )

=== debian/changelog ===
ros-crystal-behaviortree-cpp (2.4.3-1bionic) bionic; urgency=high

  * Merge branch 'master' into ros2
  * removed old file
  * Fix issue #31 : convertFromString mandatory for TreeNode::getParam, not Blackboard::get
  * 2.4.3
  * version bump
  * Merge pull request #30 from nuclearsandwich/patch-1
    Fix typo in package name.
  * Remove extra find_package(ament_cmake_gtest).
    This package should only be needed if BUILD_TESTING is on and is
    find_package'd below if ament_cmake is found and BUILD_TESTING is on.
  * Fix typo in package name.
  * added video to readme
  * Cherry piking changes from PR #19 which solve issue #2 CONAN support
  * Merge pull request #29 from nuclearsandwich/ament-gtest-dep
    Add test dependency on ament_cmake_gtest.
  * Add test dependency on ament_cmake_gtest.
  * fix travis removing CI
  * Contributors: Davide Faconti, Steven! Ragnarök

 -- Michele Colledanchise <michele.colledanchise@gmail.com>  Thu, 06 Dec 2018 23:00:00 -0000

ros-crystal-behaviortree-cpp (2.4.2-1bionic) bionic; urgency=high

  * support ament
  * change to ament
  * Contributors: Davide Faconti

 -- Michele Colledanchise <michele.colledanchise@gmail.com>  Tue, 04 Dec 2018 23:00:00 -0000

ros-crystal-behaviortree-cpp (2.4.1-1bionic) bionic; urgency=high

  * fix warnings and dependencies in ROS, mainly related to ZMQ
  * Contributors: Davide Faconti

 -- Michele Colledanchise <michele.colledanchise@gmail.com>  Tue, 04 Dec 2018 23:00:00 -0000

ros-crystal-behaviortree-cpp (2.4.0-1bionic) bionic; urgency=high

  * Merge pull request #27 from mjeronimo/bt-12-4-2018
    Add support for ament/colcon build
  * updated documentation
  * Merge pull request #25 from BehaviorTree/include_xml
    Add the ability to include an XML from another one
  * <include> supports ROS package getPath (issue #17)
  * Trying to fix writeXML (issue #24)
  * New feature: include XMl from other XMLs (issue #17)
  * more verbose error message
  * adding unit tests for Repeat and Retry nodes #23
  * Bug fix in Retry and Repeat Decorators (needs unit test)
  * Throw if the parameter in blackboard can't be read
  * Try to prevent error #22 in user code
  * changed the protocol of the XML
  * fixing issue #22
  * Contributors: Davide Faconti, Michael Jeronimo

 -- Michele Colledanchise <michele.colledanchise@gmail.com>  Tue, 04 Dec 2018 23:00:00 -0000

ros-crystal-behaviortree-cpp (2.3.0-1bionic) bionic; urgency=high

  * Fix: registerBuilder did not register the manifest. It was "broken" as public API method
  * Use the Pimpl idiom to hide zmq from the header file
  * move header of minitrace in the cpp file
  * Fixed a crash occuring when you didn't initialized a Tree object (#20)
  * Fix issue #16
  * add ParallelNode to pre-registered entries in factory (issue #13)
  * removed M_PI
  * Update the documentation
  * Contributors: Davide Faconti, Jimmy Delas

 -- Michele Colledanchise <michele.colledanchise@gmail.com>  Tue, 27 Nov 2018 23:00:00 -0000

ros-crystal-behaviortree-cpp (2.2.0-1bionic) bionic; urgency=high

  * fix typo
  * method contains() added to BlackBoard
  * back compatible API change to improve the wrapping of legacy code (issue #15)
    Eventually, SimpleAction, SimpleDecorators and SimpleCondition can use
    blackboard and NodeParameters too.
  * reduce potential memory allocations using string_view
  * fix important issue with SubtreeNode
  * Read at every tick the parameter if Blackboard is used
  * Adding NodeParameters to ParallelNode
  * travis update
  * merge pull request #14 related to #10 (with some minor changes)
  * Fix issue #8 and warning reported in #4
    Fixed problem of visibility with TinyXML2
  * Contributors: Davide Faconti, Uilian Ries

 -- Michele Colledanchise <michele.colledanchise@gmail.com>  Mon, 19 Nov 2018 23:00:00 -0000

ros-crystal-behaviortree-cpp (2.1.0-1bionic) bionic; urgency=high

  * version 2.1. New directory structure
  * Contributors: Davide Faconti

 -- Michele Colledanchise <michele.colledanchise@gmail.com>  Thu, 15 Nov 2018 23:00:00 -0000

=== debian/control ===
Source: ros-crystal-behaviortree-cpp
Section: misc
Priority: extra
Maintainer: Michele Colledanchise <michele.colledanchise@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libzmq3-dev, ros-crystal-ament-cmake, ros-crystal-ament-cmake-gtest, ros-crystal-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-crystal-behaviortree-cpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libzmq3-dev, ros-crystal-ros-workspace
Description: This package provides a behavior trees core.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/crystal/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/crystal" \
		-DAMENT_PREFIX_PATH="/opt/ros/crystal"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-crystal-behaviortree-cpp//opt/ros/crystal/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_install
